package doctor.controller;

import doctor.common.core.domain.HealthR;
import doctor.domain.vo.SickCircleVo;
import doctor.service.SickCircleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/sickCircle/v1")
public class HealthSickController {

    @Autowired
    private SickCircleService sickCircleService;

    @GetMapping("/findSickCircleList")
    public HealthR<List<SickCircleVo>> sickCircleList(@RequestParam Integer page,
                                                      @RequestParam Integer count,
                                                      @RequestParam Integer departmentId) {
        List<SickCircleVo> sickCircleList = sickCircleService.findSickCircleList(page, count, departmentId);
        return HealthR.ok(sickCircleList);
    }
}
