package doctor.service.impl;

import doctor.domain.entity.InquiryDetailsRecordEntity;
import doctor.domain.vo.DoctorVo;
import doctor.domain.vo.InquiryDetailsRecordVo;
import doctor.mapper.InquiryMapper;
import doctor.service.InquiryService;
import doctor.util.ConvertUtil;
import doctor.util.RSAUtils;
import doctor.util.RsaKey;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName : InquiryServiceImpl
 * @Description :
 * @Author : FJJ
 * @Date: 2024-01-12 19:19
 */
@Service
public class InquiryServiceImpl implements InquiryService {
    @Autowired
    private InquiryMapper inquiryMapper;
    @Override
    public List<InquiryDetailsRecordVo> findHistoryInquiryRecord() {
        List<InquiryDetailsRecordEntity> inquiryDetailsRecordEntity = inquiryMapper.findHistoryInquiryRecord();
        List<InquiryDetailsRecordVo> inquiryDetailsRecordVos = ConvertUtil.entityToVoList(inquiryDetailsRecordEntity, InquiryDetailsRecordVo.class);
        return inquiryDetailsRecordVos;
    }

    @Override
    public DoctorVo findDoctorInfo(Integer doctorId) {

        return null;
    }

    @Override
    public String consultDoctor(Integer userId, Integer doctorId) {
        inquiryMapper.consultDoctor(userId,doctorId);
        String doctorUserName = inquiryMapper.findDoctorUserNameByDoctorId(doctorId);
        try {
            String s = RSAUtils.rsaDecrypt(doctorUserName, RsaKey.PUBLIC_KEY);
            return s;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void followDoctor(Integer userId, Integer doctorId) {

    }

    @Override
    public void cancelFollow(Integer userId, Integer doctorId) {

    }

    @Override
    public void endInquiry(Integer userId, Integer recordId) {

    }
}
